/*
 * Distriblend: A distributed rendering system for Blender
 * 
 * Copyright (C) 2007: Ian Philip Thompson
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 */

package net.sf.distriblend.distributor.event;

import net.sf.distriblend.share.Task;

/**
 * @author Ian Thompson
 * 
 */
public class TaskEvent {

	/**
	 * Creates a task event for the specified task and frame number.
	 * 
	 * @param task
	 *            The task responsible for this event.
	 * @param frame
	 *            The number of the frame responsible for this event.
	 */
	public TaskEvent(Task task, int frame) {
		super();
		this.task = task;
		this.frame = frame;
	}

	/**
	 * @return The {@link Task}.
	 */
	public Task getTask() {
		return task;
	}

	/**
	 * @return The frame number.
	 */
	public int getFrame() {
		return frame;
	}

	/* -- Private -- */

	private final Task task;

	private final int frame;
}
