/*
 * Distriblend: A distributed rendering system for Blender
 * 
 * Copyright (C) 2007-2008: Ian Philip Thompson
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 */

package net.sf.distriblend.distributor.gui;

import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.security.NoSuchAlgorithmException;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPasswordField;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.JTextPane;
import javax.swing.border.TitledBorder;

import net.sf.distriblend.share.HashFunction;
import net.sf.distriblend.share.SafeString;
import net.sf.distriblend.share.Settings;

class WizardStep2 extends WizardStep {

	private JTextPane userRegistrationText = null;
	private JTextField userField = null;
	private JButton addUserButton = null;
	private JLabel userLabel = null;
	private JLabel passwordLabel = null;
	private JPasswordField passwordField = null;
	private JList userList = null;
	private SingleSortedListModel userListModel = null;
	private JScrollPane userListScrollPane = null;
	private JButton removeUserButton = null;
	private JTextPane userListText = null;

	/**
	 * This method initializes
	 * 
	 */
	public WizardStep2() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
		gridBagConstraints7.fill = GridBagConstraints.BOTH;
		gridBagConstraints7.gridy = 3;
		gridBagConstraints7.weightx = 1.0;
		gridBagConstraints7.weighty = 0.0;
		gridBagConstraints7.gridwidth = 2;
		gridBagConstraints7.insets = new Insets(4, 4, 4, 4);
		gridBagConstraints7.gridx = 0;
		GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
		gridBagConstraints6.gridx = 2;
		gridBagConstraints6.insets = new Insets(4, 4, 4, 16);
		gridBagConstraints6.anchor = GridBagConstraints.SOUTH;
		gridBagConstraints6.fill = GridBagConstraints.NONE;
		gridBagConstraints6.gridwidth = 2;
		gridBagConstraints6.gridy = 3;
		GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
		gridBagConstraints5.fill = GridBagConstraints.BOTH;
		gridBagConstraints5.gridy = 4;
		gridBagConstraints5.weightx = 1.0;
		gridBagConstraints5.weighty = 1.0;
		gridBagConstraints5.gridwidth = 5;
		gridBagConstraints5.insets = new Insets(4, 16, 16, 16);
		gridBagConstraints5.gridx = 0;
		GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
		gridBagConstraints3.fill = GridBagConstraints.BOTH;
		gridBagConstraints3.gridy = 2;
		gridBagConstraints3.weightx = 0.0;
		gridBagConstraints3.insets = new Insets(4, 4, 8, 4);
		gridBagConstraints3.gridwidth = 2;
		gridBagConstraints3.gridx = 1;
		GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
		gridBagConstraints2.gridx = 0;
		gridBagConstraints2.insets = new Insets(4, 16, 8, 4);
		gridBagConstraints2.anchor = GridBagConstraints.EAST;
		gridBagConstraints2.gridy = 2;
		passwordLabel = new JLabel();
		passwordLabel.setText("Password:");
		GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
		gridBagConstraints11.gridx = 0;
		gridBagConstraints11.insets = new Insets(8, 16, 4, 4);
		gridBagConstraints11.anchor = GridBagConstraints.EAST;
		gridBagConstraints11.gridy = 1;
		userLabel = new JLabel();
		userLabel.setText("User name:");
		GridBagConstraints gridBagConstraints40 = new GridBagConstraints();
		gridBagConstraints40.gridx = 3;
		gridBagConstraints40.anchor = GridBagConstraints.CENTER;
		gridBagConstraints40.insets = new Insets(4, 4, 8, 16);
		gridBagConstraints40.gridwidth = 1;
		gridBagConstraints40.fill = GridBagConstraints.NONE;
		gridBagConstraints40.gridheight = 1;
		gridBagConstraints40.gridy = 2;
		GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
		gridBagConstraints1.fill = GridBagConstraints.BOTH;
		gridBagConstraints1.gridy = 1;
		gridBagConstraints1.weightx = 0.0;
		gridBagConstraints1.insets = new Insets(8, 4, 4, 16);
		gridBagConstraints1.gridwidth = 3;
		gridBagConstraints1.gridx = 1;
		GridBagConstraints gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints.gridy = 0;
		gridBagConstraints.weightx = 1.0;
		gridBagConstraints.weighty = 0.0;
		gridBagConstraints.insets = new Insets(4, 4, 4, 4);
		gridBagConstraints.gridwidth = 5;
		gridBagConstraints.gridx = 0;
		this.setLayout(new GridBagLayout());
		this.setBorder(new TitledBorder(null, "Step 2 of 4",
				TitledBorder.TRAILING, TitledBorder.TOP));
		this.setSize(new Dimension(437, 275));
		this.add(getUserRegistrationText(), gridBagConstraints);
		this.add(getUserField(), gridBagConstraints1);
		this.add(getAddUserButton(), gridBagConstraints40);
		this.add(userLabel, gridBagConstraints11);
		this.add(passwordLabel, gridBagConstraints2);
		this.add(getPasswordField(), gridBagConstraints3);
		this.add(getUserListScrollPane(), gridBagConstraints5);
		this.add(getRemoveUserButton(), gridBagConstraints6);
		this.add(getUserListText(), gridBagConstraints7);
	}

	/**
	 * This method initializes userRegistrationText
	 * 
	 * @return javax.swing.JTextPane
	 */
	private JTextPane getUserRegistrationText() {
		if (userRegistrationText == null) {
			userRegistrationText = new JTextPane();
			userRegistrationText.setOpaque(false);
			userRegistrationText.setEditable(false);
			userRegistrationText.setText("To submit jobs to the distributor "
					+ "at least one user account must exist. Fill in the "
					+ "user's details and click Add User to create a new "
					+ "account.");
		}
		return userRegistrationText;
	}

	/**
	 * This method initializes userField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getUserField() {
		if (userField == null) {
			userField = new JTextField();
		}
		return userField;
	}

	/**
	 * This method initializes addUserButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getAddUserButton() {
		if (addUserButton == null) {
			addUserButton = new JButton();
			addUserButton.setText("Add User");
			addUserButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent evt) {
					String user = getUserField().getText();
					String password = new String(getPasswordField()
							.getPassword());
					if (user.equals("") || password.equals("")) {
						JOptionPane.showMessageDialog(WizardStep2.this,
								"User name and password must be filled in.",
								"Add User", JOptionPane.INFORMATION_MESSAGE);
						return;
					}
					if (!SafeString.isSafe(user)) {
						JOptionPane.showMessageDialog(WizardStep2.this,
								"The user name must be safe to use as a file "
										+ "name.", "Add User",
								JOptionPane.WARNING_MESSAGE);
						return;
					}
					File root = new File(Settings.instance().getStringProperty(
							"storage.root"));
					File userDir = new File(root, user);
					userDir.mkdir();
					File userPasswordFile = new File(userDir, "user.pwd");
					try {
						PrintWriter out = new PrintWriter(new FileOutputStream(
								userPasswordFile));
						out.println(HashFunction.getDefault().hash(password));
						out.close();
					} catch (IOException e) {
						JOptionPane.showMessageDialog(WizardStep2.this,
								"Failed to write user profile to disk.",
								"Error", JOptionPane.ERROR_MESSAGE);
						userDir.delete();
						return;
					} catch (NoSuchAlgorithmException e) {
						JOptionPane.showMessageDialog(WizardStep2.this,
								"Failed to hash password.", "Error",
								JOptionPane.ERROR_MESSAGE);
						userDir.delete();
						return;
					}
					getUserListModel().addElement(user);
					getUserField().setText("");
					getPasswordField().setText("");
				}
			});
		}
		return addUserButton;
	}

	/**
	 * This method initializes passwordField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JPasswordField getPasswordField() {
		if (passwordField == null) {
			passwordField = new JPasswordField();
		}
		return passwordField;
	}

	/**
	 * This method initializes userList
	 * 
	 * @return javax.swing.JList
	 */
	private JList getUserList() {
		if (userList == null) {
			userList = new JList();
			userList.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			userList.setModel(getUserListModel());
		}
		return userList;
	}

	/**
	 * @return the userListModel
	 */
	private SingleSortedListModel getUserListModel() {
		if (userListModel == null) {
			userListModel = new SingleSortedListModel();
		}
		return userListModel;
	}

	/**
	 * This method initializes userListScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getUserListScrollPane() {
		if (userListScrollPane == null) {
			userListScrollPane = new JScrollPane();
			userListScrollPane.setViewportView(getUserList());
		}
		return userListScrollPane;
	}

	/**
	 * This method initializes removeUserButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getRemoveUserButton() {
		if (removeUserButton == null) {
			removeUserButton = new JButton();
			removeUserButton.setText("Delete User");
			removeUserButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					int index = getUserList().getSelectedIndex();
					if (index == -1)
						return;
					String user = getUserListModel().getElementAt(index)
							.toString();

					int result = JOptionPane.showConfirmDialog(
							WizardStep2.this, "Are you sure you wish to "
									+ "delete the selected user and all of "
									+ "their files?", "Delete User?",
							JOptionPane.YES_NO_CANCEL_OPTION,
							JOptionPane.QUESTION_MESSAGE);
					if (result != JOptionPane.YES_OPTION)
						return;

					File root = new File(Settings.instance().getStringProperty(
							"storage.root"));
					File userDir = new File(root, user);
					purge(userDir);

					if (userDir.exists()) {
						JOptionPane.showMessageDialog(WizardStep2.this,
								"Delete failed.", "Delete",
								JOptionPane.ERROR_MESSAGE);
						return;
					}

					getUserListModel().removeElementAt(index);
				}
			});
		}
		return removeUserButton;
	}

	/**
	 * This method initializes userListText
	 * 
	 * @return javax.swing.JTextPane
	 */
	private JTextPane getUserListText() {
		if (userListText == null) {
			userListText = new JTextPane();
			userListText.setOpaque(false);
			userListText.setEditable(false);
			userListText.setText("The following table lists all user accounts "
					+ "on the system. To remove a user account and all "
					+ "associated files, select the account below and click "
					+ "Delete User.");
		}
		return userListText;
	}

	private void purge(File file) {
		File[] files = file.listFiles();
		if (files != null)
			for (File sub : files)
				purge(sub);
		file.delete();
	}

	@Override
	void stepEntered() {
		File root = new File(Settings.instance().getStringProperty(
				"storage.root"));
		File[] userDirs = root.listFiles();
		getUserListModel().clear();
		for (File userDir : userDirs) {
			if (userDir.isDirectory() && new File(userDir, "user.ini").exists())
				getUserListModel().addElement(userDir.getName());
		}
	}

	@Override
	boolean validateForm() {
		if (getUserListModel().getSize() != 0)
			return true;

		JOptionPane.showMessageDialog(this, "The distributor must have at "
				+ "least one user account", "Users",
				JOptionPane.WARNING_MESSAGE);
		return false;
	}
}
