/*
 * Distriblend: A distributed rendering system for Blender
 * 
 * Copyright (C) 2007-2008: Ian Philip Thompson
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 */

package net.sf.distriblend.distributor.gui;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.util.Enumeration;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.JTextPane;
import javax.swing.border.TitledBorder;

import net.sf.distriblend.share.SafeString;
import net.sf.distriblend.share.Settings;

class WizardStep3 extends WizardStep {

	private JPanel spacerPanel = null;
	private JTextPane bindText = null;
	private JLabel nodeAddressLabel = null;
	private JLabel nodePortLabel = null;
	private JTextField nodePortField = null;
	private JLabel nodeUserLabel = null;
	private JTextField nodeUserField = null;
	private JLabel nodePasswordLabel = null;
	private JPasswordField nodePasswordField = null;
	private JTextPane nodeLogonText = null;
	private JComboBox nodeAddressComboBox = null;
	private DefaultComboBoxModel nodeAddressComboBoxModel = null;
	private JLabel clientAddressLabel = null;
	private JComboBox clientAddressComboBox = null;
	private DefaultComboBoxModel clientAddressComboBoxModel = null;
	private JLabel clientPortLabel = null;
	private JTextField clientPortField = null;
	private JTextPane clientText = null;

	/**
	 * This method initializes
	 * 
	 */
	public WizardStep3() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
		gridBagConstraints5.fill = GridBagConstraints.BOTH;
		gridBagConstraints5.gridy = 0;
		gridBagConstraints5.weightx = 1.0;
		gridBagConstraints5.weighty = 0.0;
		gridBagConstraints5.gridwidth = 4;
		gridBagConstraints5.gridx = 0;
		GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
		gridBagConstraints4.fill = GridBagConstraints.BOTH;
		gridBagConstraints4.gridy = 1;
		gridBagConstraints4.weightx = 1.0;
		gridBagConstraints4.insets = new Insets(8, 4, 8, 16);
		gridBagConstraints4.gridx = 3;
		GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
		gridBagConstraints3.gridx = 2;
		gridBagConstraints3.insets = new Insets(8, 16, 8, 4);
		gridBagConstraints3.anchor = GridBagConstraints.WEST;
		gridBagConstraints3.gridy = 1;
		clientPortLabel = new JLabel();
		clientPortLabel.setText("Port:");
		GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
		gridBagConstraints2.fill = GridBagConstraints.BOTH;
		gridBagConstraints2.gridy = 1;
		gridBagConstraints2.weightx = 1.0;
		gridBagConstraints2.insets = new Insets(8, 4, 8, 4);
		gridBagConstraints2.gridx = 1;
		GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.insets = new Insets(8, 16, 8, 4);
		gridBagConstraints1.anchor = GridBagConstraints.WEST;
		gridBagConstraints1.gridy = 1;
		clientAddressLabel = new JLabel();
		clientAddressLabel.setText("Bind address:");
		GridBagConstraints gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints.gridy = 3;
		gridBagConstraints.weightx = 1.0;
		gridBagConstraints.insets = new Insets(8, 4, 8, 4);
		gridBagConstraints.gridx = 1;
		GridBagConstraints gridBagConstraints27 = new GridBagConstraints();
		gridBagConstraints27.fill = GridBagConstraints.BOTH;
		gridBagConstraints27.gridy = 4;
		gridBagConstraints27.weightx = 1.0;
		gridBagConstraints27.weighty = 0.0;
		gridBagConstraints27.gridwidth = 4;
		gridBagConstraints27.weighty = 0.0;
		gridBagConstraints27.insets = new Insets(4, 4, 4, 4);
		gridBagConstraints27.gridx = 0;
		GridBagConstraints gridBagConstraints26 = new GridBagConstraints();
		gridBagConstraints26.fill = GridBagConstraints.BOTH;
		gridBagConstraints26.gridy = 5;
		gridBagConstraints26.weightx = 1.0;
		gridBagConstraints26.insets = new Insets(8, 4, 8, 16);
		gridBagConstraints26.gridx = 3;
		GridBagConstraints gridBagConstraints25 = new GridBagConstraints();
		gridBagConstraints25.gridx = 2;
		gridBagConstraints25.insets = new Insets(8, 16, 8, 4);
		gridBagConstraints25.anchor = GridBagConstraints.EAST;
		gridBagConstraints25.gridy = 5;
		nodePasswordLabel = new JLabel();
		nodePasswordLabel.setText("Password:");
		GridBagConstraints gridBagConstraints24 = new GridBagConstraints();
		gridBagConstraints24.fill = GridBagConstraints.BOTH;
		gridBagConstraints24.gridy = 5;
		gridBagConstraints24.weightx = 1.0;
		gridBagConstraints24.insets = new Insets(8, 4, 8, 4);
		gridBagConstraints24.gridx = 1;
		GridBagConstraints gridBagConstraints23 = new GridBagConstraints();
		gridBagConstraints23.gridx = 0;
		gridBagConstraints23.insets = new Insets(8, 16, 8, 4);
		gridBagConstraints23.anchor = GridBagConstraints.WEST;
		gridBagConstraints23.gridy = 5;
		nodeUserLabel = new JLabel();
		nodeUserLabel.setText("User:");
		GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
		gridBagConstraints22.fill = GridBagConstraints.BOTH;
		gridBagConstraints22.gridy = 3;
		gridBagConstraints22.weightx = 1.0;
		gridBagConstraints22.insets = new Insets(8, 4, 8, 16);
		gridBagConstraints22.gridx = 3;
		GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
		gridBagConstraints21.gridx = 2;
		gridBagConstraints21.insets = new Insets(8, 16, 8, 4);
		gridBagConstraints21.weightx = 0.0;
		gridBagConstraints21.anchor = GridBagConstraints.WEST;
		gridBagConstraints21.gridy = 3;
		nodePortLabel = new JLabel();
		nodePortLabel.setText("Port:");
		GridBagConstraints gridBagConstraints19 = new GridBagConstraints();
		gridBagConstraints19.gridx = 0;
		gridBagConstraints19.insets = new Insets(8, 16, 8, 4);
		gridBagConstraints19.anchor = GridBagConstraints.WEST;
		gridBagConstraints19.gridy = 3;
		nodeAddressLabel = new JLabel();
		nodeAddressLabel.setText("Bind address:");
		GridBagConstraints gridBagConstraints18 = new GridBagConstraints();
		gridBagConstraints18.fill = GridBagConstraints.BOTH;
		gridBagConstraints18.gridy = 2;
		gridBagConstraints18.weightx = 1.0;
		gridBagConstraints18.weighty = 0.0;
		gridBagConstraints18.gridwidth = 4;
		gridBagConstraints18.weighty = 0.0;
		gridBagConstraints18.insets = new Insets(4, 4, 4, 4);
		gridBagConstraints18.gridx = 0;
		GridBagConstraints gridBagConstraints17 = new GridBagConstraints();
		gridBagConstraints17.gridx = 0;
		gridBagConstraints17.weightx = 1.0;
		gridBagConstraints17.weighty = 1.0;
		gridBagConstraints17.fill = GridBagConstraints.BOTH;
		gridBagConstraints17.gridwidth = 4;
		gridBagConstraints17.gridy = 6;
		this.setLayout(new GridBagLayout());
		this.setBorder(new TitledBorder(null, "Step 3 of 4",
				TitledBorder.TRAILING, TitledBorder.TOP));
		this.setSize(new Dimension(509, 296));
		this.add(getSpacerPanel(), gridBagConstraints17);
		this.add(getBindText(), gridBagConstraints18);
		this.add(nodeAddressLabel, gridBagConstraints19);
		this.add(nodePortLabel, gridBagConstraints21);
		this.add(getNodePortField(), gridBagConstraints22);
		this.add(nodeUserLabel, gridBagConstraints23);
		this.add(getNodeUserField(), gridBagConstraints24);
		this.add(nodePasswordLabel, gridBagConstraints25);
		this.add(getNodePasswordField(), gridBagConstraints26);
		this.add(getNodeLogonText(), gridBagConstraints27);
		this.add(getNodeAddressComboBox(), gridBagConstraints);
		this.add(clientAddressLabel, gridBagConstraints1);
		this.add(getClientAddressComboBox(), gridBagConstraints2);
		this.add(clientPortLabel, gridBagConstraints3);
		this.add(getClientPortField(), gridBagConstraints4);
		this.add(getClientText(), gridBagConstraints5);
	}

	/**
	 * This method initializes spacerPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getSpacerPanel() {
		if (spacerPanel == null) {
			spacerPanel = new JPanel();
			spacerPanel.setLayout(new GridBagLayout());
		}
		return spacerPanel;
	}

	/**
	 * This method initializes bindText
	 * 
	 * @return javax.swing.JTextPane
	 */
	private JTextPane getBindText() {
		if (bindText == null) {
			bindText = new JTextPane();
			bindText.setOpaque(false);
			bindText.setDisabledTextColor(getBindText().getForeground());
			bindText.setEditable(false);
			bindText
					.setText("Choose an address and port to listen on (the nodes will need to connect to this address). Leaving the address blank will let the distributor listen on all addresses. If you are unsure, this is usually the best option.");
		}
		return bindText;
	}

	/**
	 * This method initializes nodePortField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getNodePortField() {
		if (nodePortField == null) {
			nodePortField = new JTextField();
			nodePortField.setText("55101");
		}
		return nodePortField;
	}

	/**
	 * This method initializes nodeUserField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getNodeUserField() {
		if (nodeUserField == null) {
			nodeUserField = new JTextField();
			nodeUserField.setText("node");
		}
		return nodeUserField;
	}

	/**
	 * This method initializes nodePasswordField
	 * 
	 * @return javax.swing.JPasswordField
	 */
	private JPasswordField getNodePasswordField() {
		if (nodePasswordField == null) {
			nodePasswordField = new JPasswordField();
			nodePasswordField.setText("password");
		}
		return nodePasswordField;
	}

	/**
	 * This method initializes nodeLogonText
	 * 
	 * @return javax.swing.JTextPane
	 */
	private JTextPane getNodeLogonText() {
		if (nodeLogonText == null) {
			nodeLogonText = new JTextPane();
			nodeLogonText.setOpaque(false);
			nodeLogonText.setDisabledTextColor(getNodeLogonText()
					.getForeground());
			nodeLogonText.setEditable(false);
			nodeLogonText
					.setText("Enter the username and password that each node should use when connecting to this distributor:");
		}
		return nodeLogonText;
	}

	/**
	 * This method initializes nodeAddressComboBox
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getNodeAddressComboBox() {
		if (nodeAddressComboBox == null) {
			nodeAddressComboBox = new JComboBox();
			nodeAddressComboBox.setEditable(true);
			nodeAddressComboBox.setModel(getNodeAddressComboBoxModel());
		}
		return nodeAddressComboBox;
	}

	/**
	 * @return the nodeAddressComboBoxModel
	 */
	private DefaultComboBoxModel getNodeAddressComboBoxModel() {
		if (nodeAddressComboBoxModel == null) {
			nodeAddressComboBoxModel = new DefaultComboBoxModel();
		}
		return nodeAddressComboBoxModel;
	}

	/**
	 * This method initializes clientAddressComboBox
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getClientAddressComboBox() {
		if (clientAddressComboBox == null) {
			clientAddressComboBox = new JComboBox();
			clientAddressComboBox.setEditable(true);
			clientAddressComboBox.setModel(getClientAddressComboBoxModel());
		}
		return clientAddressComboBox;
	}

	/**
	 * @return the clientAddressComboBoxModel
	 */
	private DefaultComboBoxModel getClientAddressComboBoxModel() {
		if (clientAddressComboBoxModel == null) {
			clientAddressComboBoxModel = new DefaultComboBoxModel();
		}
		return clientAddressComboBoxModel;
	}

	/**
	 * This method initializes clientPortField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getClientPortField() {
		if (clientPortField == null) {
			clientPortField = new JTextField();
			clientPortField.setText("55100");
		}
		return clientPortField;
	}

	/**
	 * This method initializes clientText
	 * 
	 * @return javax.swing.JTextPane
	 */
	private JTextPane getClientText() {
		if (clientText == null) {
			clientText = new JTextPane();
			clientText.setOpaque(false);
			clientText.setDisabledTextColor(getClientText().getForeground());
			clientText.setEditable(false);
			clientText
					.setText("Select an address and port to listen on for client connections. Leaving the address blank will let the distributor listen on all addresses. If you are unsure, this is usually the best option.");
		}
		return clientText;
	}

	@Override
	void stepEntered() {
		/* Generate list of bindable IP addresses. */
		try {
			Enumeration<NetworkInterface> nins = NetworkInterface
					.getNetworkInterfaces();
			getClientAddressComboBoxModel().removeAllElements();
			getNodeAddressComboBoxModel().removeAllElements();
			getClientAddressComboBoxModel().addElement("");
			getNodeAddressComboBoxModel().addElement("");
			while (nins.hasMoreElements()) {
				NetworkInterface ni = nins.nextElement();
				Enumeration<InetAddress> adds = ni.getInetAddresses();
				while (adds.hasMoreElements()) {
					InetAddress add = adds.nextElement();
					getClientAddressComboBoxModel().addElement(
							add.getHostAddress());
					getNodeAddressComboBoxModel().addElement(
							add.getHostAddress());
				}
			}
		} catch (Exception e) {
		}
	}

	private void updateSettings() {
		Settings set = Settings.instance();
		set.setStringProperty("server.client.bind", getClientAddressComboBox()
				.getSelectedItem().toString());
		set.setStringProperty("server.client.port", getClientPortField()
				.getText());
		set.setStringProperty("server.node.bind", getNodeAddressComboBox()
				.getSelectedItem().toString());
		set.setStringProperty("server.node.port", getNodePortField().getText());
		set.setStringProperty("server.node.user", getNodeUserField().getText());
		set.setStringProperty("server.node.password", new String(
				getNodePasswordField().getPassword()));
	}

	@Override
	boolean validateForm() {
		String user = getNodeUserField().getText();
		if (user.equals("") || getNodePasswordField().getPassword().length == 0) {
			JOptionPane.showMessageDialog(this,
					"User name and password must be set.",
					"User/password not set", JOptionPane.WARNING_MESSAGE);
			return false;
		}
		if (!SafeString.isSafe(user)) {
			JOptionPane.showMessageDialog(WizardStep3.this,
					"The user name must be a valid and safe file name.",
					"Add User", JOptionPane.WARNING_MESSAGE);
			return false;
		}

		int clientPort = -1;
		int nodePort = -1;
		try {
			clientPort = Integer.parseInt(getClientPortField().getText());
			nodePort = Integer.parseInt(getNodePortField().getText());
		} catch (Exception e) {
		}
		if (clientPort < 1 || clientPort > 65535 || nodePort < 1
				|| nodePort > 65535) {
			JOptionPane.showMessageDialog(this,
					"Port values must be numbers between 1 and 65535.",
					"Invalid Port", JOptionPane.WARNING_MESSAGE);
			return false;
		}

		updateSettings();
		return true;
	}
}
