/*
 * Distriblend: A distributed rendering system for Blender
 * 
 * Copyright (C) 2007: Ian Philip Thompson
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 */

package net.sf.distriblend.share;

import java.io.Serializable;

/**
 * A convenience class for holding a {@link Task}-frame pair.
 * 
 * @author Ian Thompson
 * 
 */
public class TaskFrame implements Serializable {

	/**
	 * Creates a task-frame pair.
	 * 
	 * @param task
	 * @param frame
	 */
	public TaskFrame(Task task, int frame) {
		this.task = task;
		this.frame = frame;
	}

	/**
	 * @return the task
	 */
	public Task getTask() {
		return task;
	}

	/**
	 * @return the frame
	 */
	public int getFrame() {
		return frame;
	}

	private final Task task;

	private final int frame;
}